Subject: Re: kernel panic removing devices from a teql queuing discipline

From: Evgeniy Polyakov <[email-masked]>
Date: Mon, 5 Nov 2007 23:08:00 +0300

On Tue, Oct 30, 2007 at 01:33:41AM -0700, David Miller ([email-masked]) wrote:
> > The panic is in __teql_resolve (which has been inlined into teql_master_xmit) in
> > net/sched/sch_teql.c at this line:
> > 
> > 	if (n && n->tbl == mn->tbl &&
> > 
> > Specifically the dereference of n->tbl is faulting as n is not valid.

n is never valid (null), mn is garbage.

> > And the address looks like part of an ASCCI string...  "figt"
> 
> I studied sch_teql.c a bit and I suspect that the slave list
> management in teql_destroy() and teql_qdisc_init() might be
> suspect.

tecl_reset() is called from deactivate and qdisc is set to noop already,
but subsequent teql_xmit does not know about it and dereference private
data as teql qdisc and thus oopses. I will fix it tomorrow if you will
not catch it first :)

-- 
	Evgeniy Polyakov